=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class Article
    # Unique identifier for article
    attr_accessor :id

    # Title of article
    attr_accessor :title

    # DOI
    attr_accessor :doi

    # Handle
    attr_accessor :handle

    # Api endpoint for article
    attr_accessor :url

    # Public site endpoint for article
    attr_accessor :url_public_html

    # Public Api endpoint for article
    attr_accessor :url_public_api

    # Private site endpoint for article
    attr_accessor :url_private_html

    # Private Api endpoint for article
    attr_accessor :url_private_api

    # Various timeline dates
    attr_accessor :timeline

    # Thumbnail image
    attr_accessor :thumb

    # Type of article identifier
    attr_accessor :defined_type

    # Name of the article type identifier
    attr_accessor :defined_type_name

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'title' => :'title',
        :'doi' => :'doi',
        :'handle' => :'handle',
        :'url' => :'url',
        :'url_public_html' => :'url_public_html',
        :'url_public_api' => :'url_public_api',
        :'url_private_html' => :'url_private_html',
        :'url_private_api' => :'url_private_api',
        :'timeline' => :'timeline',
        :'thumb' => :'thumb',
        :'defined_type' => :'defined_type',
        :'defined_type_name' => :'defined_type_name'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'Integer',
        :'title' => :'String',
        :'doi' => :'String',
        :'handle' => :'String',
        :'url' => :'String',
        :'url_public_html' => :'String',
        :'url_public_api' => :'String',
        :'url_private_html' => :'String',
        :'url_private_api' => :'String',
        :'timeline' => :'Timeline',
        :'thumb' => :'String',
        :'defined_type' => :'Integer',
        :'defined_type_name' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'doi')
        self.doi = attributes[:'doi']
      end

      if attributes.has_key?(:'handle')
        self.handle = attributes[:'handle']
      end

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'url_public_html')
        self.url_public_html = attributes[:'url_public_html']
      end

      if attributes.has_key?(:'url_public_api')
        self.url_public_api = attributes[:'url_public_api']
      end

      if attributes.has_key?(:'url_private_html')
        self.url_private_html = attributes[:'url_private_html']
      end

      if attributes.has_key?(:'url_private_api')
        self.url_private_api = attributes[:'url_private_api']
      end

      if attributes.has_key?(:'timeline')
        self.timeline = attributes[:'timeline']
      end

      if attributes.has_key?(:'thumb')
        self.thumb = attributes[:'thumb']
      end

      if attributes.has_key?(:'defined_type')
        self.defined_type = attributes[:'defined_type']
      end

      if attributes.has_key?(:'defined_type_name')
        self.defined_type_name = attributes[:'defined_type_name']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @title.nil?
        invalid_properties.push('invalid value for "title", title cannot be nil.')
      end

      if @doi.nil?
        invalid_properties.push('invalid value for "doi", doi cannot be nil.')
      end

      if @handle.nil?
        invalid_properties.push('invalid value for "handle", handle cannot be nil.')
      end

      if @url.nil?
        invalid_properties.push('invalid value for "url", url cannot be nil.')
      end

      if @url_public_html.nil?
        invalid_properties.push('invalid value for "url_public_html", url_public_html cannot be nil.')
      end

      if @url_public_api.nil?
        invalid_properties.push('invalid value for "url_public_api", url_public_api cannot be nil.')
      end

      if @url_private_html.nil?
        invalid_properties.push('invalid value for "url_private_html", url_private_html cannot be nil.')
      end

      if @url_private_api.nil?
        invalid_properties.push('invalid value for "url_private_api", url_private_api cannot be nil.')
      end

      if @timeline.nil?
        invalid_properties.push('invalid value for "timeline", timeline cannot be nil.')
      end

      if @thumb.nil?
        invalid_properties.push('invalid value for "thumb", thumb cannot be nil.')
      end

      if @defined_type.nil?
        invalid_properties.push('invalid value for "defined_type", defined_type cannot be nil.')
      end

      if @defined_type_name.nil?
        invalid_properties.push('invalid value for "defined_type_name", defined_type_name cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @title.nil?
      return false if @doi.nil?
      return false if @handle.nil?
      return false if @url.nil?
      return false if @url_public_html.nil?
      return false if @url_public_api.nil?
      return false if @url_private_html.nil?
      return false if @url_private_api.nil?
      return false if @timeline.nil?
      return false if @thumb.nil?
      return false if @defined_type.nil?
      return false if @defined_type_name.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          title == o.title &&
          doi == o.doi &&
          handle == o.handle &&
          url == o.url &&
          url_public_html == o.url_public_html &&
          url_public_api == o.url_public_api &&
          url_private_html == o.url_private_html &&
          url_private_api == o.url_private_api &&
          timeline == o.timeline &&
          thumb == o.thumb &&
          defined_type == o.defined_type &&
          defined_type_name == o.defined_type_name
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, title, doi, handle, url, url_public_html, url_public_api, url_private_html, url_private_api, timeline, thumb, defined_type, defined_type_name].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
