=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class ArticleUpdate
    # Title of article
    attr_accessor :title

    # The article description. In a publisher case, usually this is the remote article description
    attr_accessor :description

    # True if article has no files
    attr_accessor :is_metadata_record

    # Article metadata reason
    attr_accessor :metadata_reason

    # List of tags to be associated with the article. Keywords can be used instead
    attr_accessor :tags

    # List of tags to be associated with the article. Tags can be used instead
    attr_accessor :keywords

    # List of links to be associated with the article (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])
    attr_accessor :references

    # List of related materials; supersedes references and resource DOI/title.
    attr_accessor :related_materials

    # List of category ids to be associated with the article(e.g [1, 23, 33, 66])
    attr_accessor :categories

    # List of category source ids to be associated with the article, supersedes the categories property
    attr_accessor :categories_by_source_id

    # List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.
    attr_accessor :authors

    # List of key, values pairs to be associated with the article
    attr_accessor :custom_fields

    # List of custom fields values, supersedes custom_fields parameter
    attr_accessor :custom_fields_list

    # <b>One of:</b> <code>figure</code> <code>online resource</code> <code>preprint</code> <code>book</code> <code>conference contribution</code> <code>media</code> <code>dataset</code> <code>poster</code> <code>journal contribution</code> <code>presentation</code> <code>thesis</code> <code>software</code>
    attr_accessor :defined_type

    # Grant number or funding authority
    attr_accessor :funding

    # Funding creation / update items
    attr_accessor :funding_list

    # License id for this article.
    attr_accessor :license

    # Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
    attr_accessor :doi

    # Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.
    attr_accessor :handle

    # Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.
    attr_accessor :resource_doi

    # Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.
    attr_accessor :resource_title

    # Various timeline dates
    attr_accessor :timeline

    # If true, downloading of files for this article is disabled
    attr_accessor :download_disabled

    # Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups
    attr_accessor :group_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'title' => :'title',
        :'description' => :'description',
        :'is_metadata_record' => :'is_metadata_record',
        :'metadata_reason' => :'metadata_reason',
        :'tags' => :'tags',
        :'keywords' => :'keywords',
        :'references' => :'references',
        :'related_materials' => :'related_materials',
        :'categories' => :'categories',
        :'categories_by_source_id' => :'categories_by_source_id',
        :'authors' => :'authors',
        :'custom_fields' => :'custom_fields',
        :'custom_fields_list' => :'custom_fields_list',
        :'defined_type' => :'defined_type',
        :'funding' => :'funding',
        :'funding_list' => :'funding_list',
        :'license' => :'license',
        :'doi' => :'doi',
        :'handle' => :'handle',
        :'resource_doi' => :'resource_doi',
        :'resource_title' => :'resource_title',
        :'timeline' => :'timeline',
        :'download_disabled' => :'download_disabled',
        :'group_id' => :'group_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'title' => :'String',
        :'description' => :'String',
        :'is_metadata_record' => :'BOOLEAN',
        :'metadata_reason' => :'String',
        :'tags' => :'Array<String>',
        :'keywords' => :'Array<String>',
        :'references' => :'Array<String>',
        :'related_materials' => :'Array<RelatedMaterial>',
        :'categories' => :'Array<Integer>',
        :'categories_by_source_id' => :'Array<String>',
        :'authors' => :'Array<Object>',
        :'custom_fields' => :'Object',
        :'custom_fields_list' => :'Array<CustomArticleFieldAdd>',
        :'defined_type' => :'String',
        :'funding' => :'String',
        :'funding_list' => :'Array<FundingCreate>',
        :'license' => :'Integer',
        :'doi' => :'String',
        :'handle' => :'String',
        :'resource_doi' => :'String',
        :'resource_title' => :'String',
        :'timeline' => :'TimelineUpdate',
        :'download_disabled' => :'BOOLEAN',
        :'group_id' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      else
        self.description = ''
      end

      if attributes.has_key?(:'is_metadata_record')
        self.is_metadata_record = attributes[:'is_metadata_record']
      end

      if attributes.has_key?(:'metadata_reason')
        self.metadata_reason = attributes[:'metadata_reason']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'keywords')
        if (value = attributes[:'keywords']).is_a?(Array)
          self.keywords = value
        end
      end

      if attributes.has_key?(:'references')
        if (value = attributes[:'references']).is_a?(Array)
          self.references = value
        end
      end

      if attributes.has_key?(:'related_materials')
        if (value = attributes[:'related_materials']).is_a?(Array)
          self.related_materials = value
        end
      end

      if attributes.has_key?(:'categories')
        if (value = attributes[:'categories']).is_a?(Array)
          self.categories = value
        end
      end

      if attributes.has_key?(:'categories_by_source_id')
        if (value = attributes[:'categories_by_source_id']).is_a?(Array)
          self.categories_by_source_id = value
        end
      end

      if attributes.has_key?(:'authors')
        if (value = attributes[:'authors']).is_a?(Array)
          self.authors = value
        end
      end

      if attributes.has_key?(:'custom_fields')
        self.custom_fields = attributes[:'custom_fields']
      end

      if attributes.has_key?(:'custom_fields_list')
        if (value = attributes[:'custom_fields_list']).is_a?(Array)
          self.custom_fields_list = value
        end
      end

      if attributes.has_key?(:'defined_type')
        self.defined_type = attributes[:'defined_type']
      end

      if attributes.has_key?(:'funding')
        self.funding = attributes[:'funding']
      else
        self.funding = ''
      end

      if attributes.has_key?(:'funding_list')
        if (value = attributes[:'funding_list']).is_a?(Array)
          self.funding_list = value
        end
      end

      if attributes.has_key?(:'license')
        self.license = attributes[:'license']
      else
        self.license = 0
      end

      if attributes.has_key?(:'doi')
        self.doi = attributes[:'doi']
      else
        self.doi = ''
      end

      if attributes.has_key?(:'handle')
        self.handle = attributes[:'handle']
      else
        self.handle = ''
      end

      if attributes.has_key?(:'resource_doi')
        self.resource_doi = attributes[:'resource_doi']
      else
        self.resource_doi = ''
      end

      if attributes.has_key?(:'resource_title')
        self.resource_title = attributes[:'resource_title']
      else
        self.resource_title = ''
      end

      if attributes.has_key?(:'timeline')
        self.timeline = attributes[:'timeline']
      end

      if attributes.has_key?(:'download_disabled')
        self.download_disabled = attributes[:'download_disabled']
      end

      if attributes.has_key?(:'group_id')
        self.group_id = attributes[:'group_id']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@title.nil? && @title.to_s.length > 1000
        invalid_properties.push('invalid value for "title", the character length must be smaller than or equal to 1000.')
      end

      if !@title.nil? && @title.to_s.length < 3
        invalid_properties.push('invalid value for "title", the character length must be great than or equal to 3.')
      end

      if !@description.nil? && @description.to_s.length > 10000
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 10000.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@title.nil? && @title.to_s.length > 1000
      return false if !@title.nil? && @title.to_s.length < 3
      return false if !@description.nil? && @description.to_s.length > 10000
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] title Value to be assigned
    def title=(title)
      if !title.nil? && title.to_s.length > 1000
        fail ArgumentError, 'invalid value for "title", the character length must be smaller than or equal to 1000.'
      end

      if !title.nil? && title.to_s.length < 3
        fail ArgumentError, 'invalid value for "title", the character length must be great than or equal to 3.'
      end

      @title = title
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 10000
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 10000.'
      end

      @description = description
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          title == o.title &&
          description == o.description &&
          is_metadata_record == o.is_metadata_record &&
          metadata_reason == o.metadata_reason &&
          tags == o.tags &&
          keywords == o.keywords &&
          references == o.references &&
          related_materials == o.related_materials &&
          categories == o.categories &&
          categories_by_source_id == o.categories_by_source_id &&
          authors == o.authors &&
          custom_fields == o.custom_fields &&
          custom_fields_list == o.custom_fields_list &&
          defined_type == o.defined_type &&
          funding == o.funding &&
          funding_list == o.funding_list &&
          license == o.license &&
          doi == o.doi &&
          handle == o.handle &&
          resource_doi == o.resource_doi &&
          resource_title == o.resource_title &&
          timeline == o.timeline &&
          download_disabled == o.download_disabled &&
          group_id == o.group_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [title, description, is_metadata_record, metadata_reason, tags, keywords, references, related_materials, categories, categories_by_source_id, authors, custom_fields, custom_fields_list, defined_type, funding, funding_list, license, doi, handle, resource_doi, resource_title, timeline, download_disabled, group_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
